<?php
namespace Pinpoint\Conesso\Console\Command\Orders;

use Magento\Sales\Api\Data\OrderInterfaceFactory;
use Pinpoint\Conesso\Model\Api\Orders\LogOrderInterface;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class Migrate Orders Command
 */
class MigrateOrdersCommand extends Command
{

    /** @var \Magento\Sales\Api\Data\OrderInterfaceFactory $order **/
    private $order;

    private $logOrder;

    public function __construct(
        OrderInterfaceFactory $order,
        LogOrderInterface $logOrder
    ) {
        $this->order = $order;
        $this->logOrder = $logOrder;
        parent::__construct();
    }
    /**
     * @inheritDoc
     */
    protected function configure()
    {
        $this->setName('conesso:migrate:orders');
        $this->setDescription('Truncate all existing rows of conesso order table and populate table with new entry.');
        parent::configure();
    }

    /**
     * Execute the command
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     *
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $order = $this->order->create()->loadByIncrementId('000000010');
        $this->logOrder->logOrders($order,'save');
        $output->writeln('<info>Success Message.</info>');
        return 0;
    }
}
