<?php
namespace Pinpoint\Conesso\Console\Command\Products;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class  Sync Products Command
 */
class SyncProductsCommand extends Command
{
    const BATCH_SIZE = 'batch_size';
    const STORE_ID = 'store_id';
    /**
     * @inheritDoc
     */
    protected function configure()
    {
        $this->setName('conesso:sync:products');
        $this->setDescription('Forced running of all pending events.');

        $this->addOption(
            self::BATCH_SIZE,
            null,
            InputOption::VALUE_OPTIONAL,
            'Batch Size'
        );

        $this->addOption(
            self::STORE_ID,
            null,
            InputOption::VALUE_OPTIONAL,
            'Store Id'
        );

        parent::configure();
    }

    /**
     * Execute the command
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     *
     * @return null|int
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $output->writeln('<info>Success Message.</info>');
        $output->writeln('<error>An error encountered.</error>');
        $output->writeln('<comment>Some Comment.</comment>');
        return 0;
    }
}
