<?php
namespace Pinpoint\Conesso\Model\Api\Orders;

use Pinpoint\Conesso\Api\Repository\OrdersSyncRepositoryInterface;
use Pinpoint\Conesso\Api\Data\OrderSyncInterfaceFactory;
use Pinpoint\Conesso\Api\Data\OrderSyncInterface;
use Magento\Store\Model\StoreManagerInterface;

class LogOrder implements  LogOrderInterface
{
    private $orderSyncFactory;

    private $ordersSyncRepository;

    private $storeManager;
    public function __construct(
        OrdersSyncRepositoryInterface $ordersSyncRepository,
        OrderSyncInterfaceFactory $orderSyncFactory,
        StoreManagerInterface $storeManager
    ) {
        $this->ordersSyncRepository = $ordersSyncRepository;
        $this->orderSyncFactory = $orderSyncFactory;
        $this->storeManager = $storeManager;
    }
    public function logOrders(\Magento\Sales\Api\Data\OrderInterface $order, $eventType)
    {
        $orderData = $this->orderSyncFactory->create();
        $data = [
            OrderSyncInterface::STORE_ID => (int) $this->storeManager->getStore()->getStoreId(),
            OrderSyncInterface::ORDER_ID => (int) $order->getEntityId(),
            OrderSyncInterface::INCREMENT_ID => $order->getIncrementId(),
            OrderSyncInterface::EVENT_TYPE => $eventType,
            OrderSyncInterface::IS_SYNCED => 0,

        ];
        $orderData->setData($data);
        $this->ordersSyncRepository->save($orderData);
    }
}
