<?php
namespace Pinpoint\Conesso\Model\Api\Repository;

use Pinpoint\Conesso\Api\Data\OrderSyncInterface;
use Pinpoint\Conesso\Api\Repository\OrdersSyncRepositoryInterface;
use Pinpoint\Conesso\Model\ResourceModel\SyncOrders\CollectionFactory;
use Pinpoint\Conesso\Model\ResourceModel\SyncOrders as SyncOrdersResourceModel;
use Pinpoint\Conesso\Api\Data\OrderSyncInterfaceFactory;
use Magento\Framework\Exception\CouldNotSaveException;

class OrdersSyncRepository implements OrdersSyncRepositoryInterface
{
    private $syncOrdersCollectionFactory;

    private $orderSyncFactory;

    private $syncOrdersResourceModel;

    public function __construct(
        CollectionFactory $syncOrdersCollectionFactory,
        SyncOrdersResourceModel $syncOrdersResourceModel,
        OrderSyncInterfaceFactory $orderSyncFactory
    ) {
        $this->orderSyncFactory = $orderSyncFactory;
        $this->syncOrdersResourceModel = $syncOrdersResourceModel;
        $this->syncOrdersCollectionFactory = $syncOrdersCollectionFactory;
    }

    public function save(OrderSyncInterface $orderSync)
    {
        try {
            /** @var \Pinpoint\Conesso\Model\SyncOrders|\Magento\Framework\Model\AbstractModel $wishList */
            $this->syncOrdersResourceModel->save($orderSync);
            $x = $orderSync;
            return $orderSync;
        } catch (\Exception $e) {
            throw new CouldNotSaveException(__(
                'Could not save the entity: %1',
                $e->getMessage()
            ));
        }
    }

//    public function get(int $id): OrderSyncInterface
//    {
//
//    }

    public function delete(OrderSyncInterface $orderSync): bool
    {
        $this->syncOrdersResourceModel->delete($orderSync);
        return true;
    }

    public function deleteById(int $id): bool
    {
        try {
            $syncOrders = $this->syncOrdersCollectionFactory->create()
                ->addFieldToFilter('id', ['in' => $id]);
            $syncOrders->walk('delete');
            return true;
        } catch (\Exception $e) {
            return false;
        }
    }
}
